/* These are type specifications for a simple dictionary package.       */

#include "dc_instantiate.h"   /* contains ky_type, in_type declarations */
                              /* and macros                             */
#define NULL_ITEM NULL 

typedef struct cell {         /* (private) cell type */ 
         ky_type dkey; 
         struct cell   *parent; 
         struct cell   *lch;
         struct cell   *rch;
         in_type dinfo; 
    } celltype;

typedef struct {                /* (private) priority queue type */ 
         int         mydsize;      /* current size                  */
         struct cell *mydroot;       /* point to root*/
       } mydict;

typedef struct cell *it_type;    /* PUBLIC: type locates item via lookup  */ 
typedef mydict      *dict_ptr;    /* PUBLIC: type points to prioroty queue */ 

